# Class TabBarWebElement

The component WebElement for oj-c-tab-bar. Do not instantiate this class directly, instead, use findTabBar.

#### Hierarchy

- TabBarWebElementBase
  - TabBarWebElement

#####
Index

### Constructors

constructor

### Methods

changeSelection
clear
click
doRemove
doReorder
doSelection
findElement
findElements
getAttribute
getCssValue
getData
getDisplay
getDriver
getEdge
getId
getLayout
getLocation
getOverflow
getProperty
getRect
getReorderable
getSelection
getShadowRoot
getSize
getTagName
getText
getTruncation
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new TabBarWebElement(el, locators): TabBarWebElement

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns TabBarWebElement

  Inherited from TabBarWebElementBase.constructor

## Methods

### changeSelection

- changeSelection(selection): Promise<void>

- Sets the value of `selection` property. The key of the selected tab

  #### Parameters

  - ##### selection: string | number

    The value to set for `selection`

  #### Returns Promise<void>

  Inherited from TabBarWebElementBase.changeSelection

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.clear

### click

- click(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.click

### doRemove

- doRemove<K>(key): Promise<void>

- Remove tab specified by key.

  #### Type Parameters

  - #### K

  #### Parameters

  - ##### key: K

    key of the tab to be removed

  #### Returns Promise<void>

  #### Typeparam

  K Type of keys

### doReorder

- doReorder<K>(key, position): Promise<any>

- Selects tab specified by key. Put the tab to the specified place

  #### Type Parameters

  - #### K

  #### Parameters

  - ##### key: K

    key of the tab to be reordered

  - ##### position: {
    index: number;
    } | {
    key: null | K;
    }

    the index or the key of the tab that user want to move in front of, if the key is null, the tab will move to the end of the tabbar

  #### Returns Promise<any>

  #### Typeparam

  K Type of keys

  #### Typeparam

  number Type of index

### doSelection

- doSelection<K>(key): Promise<void>

- Selects tab specified by key. Triggers ojSelectionAction regardless if the key passed is same as the current selection value or not.

  #### Type Parameters

  - #### K

  #### Parameters

  - ##### key: K

    key of the tab to be selected

  #### Returns Promise<void>

  #### Typeparam

  K Type of keys

### findElement

- findElement(locator): WebElementPromise

- #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  #### Inherit Doc

  Inherited from TabBarWebElementBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.findElements

### getAttribute

- getAttribute(attributeName): Promise<string>

- #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.getAttribute

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.getCssValue

### getData

- getData(): Promise<object[]>

- Gets the value of `data` property. An array of tabs

  #### Returns Promise<object[]>

  The value of `data` property.

  Inherited from TabBarWebElementBase.getData

### getDisplay

- getDisplay(): Promise<string>

- Gets the value of `display` property. The display configuration for tabs.

  #### Returns Promise<string>

  The value of `display` property.

  Inherited from TabBarWebElementBase.getDisplay

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from TabBarWebElementBase.getDriver

### getEdge

- getEdge(): Promise<string>

- Gets the value of `edge` property. The edge configuration for tabs.

  #### Returns Promise<string>

  The value of `edge` property.

  Inherited from TabBarWebElementBase.getEdge

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from TabBarWebElementBase.getId

### getLayout

- getLayout(): Promise<string>

- Gets the value of `layout` property. The layout configuration for tabs.

  #### Returns Promise<string>

  The value of `layout` property.

  Inherited from TabBarWebElementBase.getLayout

### getLocation

- getLocation(): Promise<ILocation>

- #### Returns Promise<ILocation>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.getLocation

### getOverflow

- getOverflow(): Promise<string>

- Gets the value of `overflow` property. Specifies the overflow behavior.

  #### Returns Promise<string>

  The value of `overflow` property.

  Inherited from TabBarWebElementBase.getOverflow

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from TabBarWebElementBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- #### Returns Promise<IRectangle>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.getRect

### getReorderable

- getReorderable(): Promise<string>

- Gets the value of `reorderable` property. The reorderable configuration for tabs.

  #### Returns Promise<string>

  The value of `reorderable` property.

  Inherited from TabBarWebElementBase.getReorderable

### getSelection

- getSelection(): Promise<string | number>

- Gets the value of `selection` property. The key of the selected tab

  #### Returns Promise<string | number>

  The value of `selection` property.

  Inherited from TabBarWebElementBase.getSelection

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from TabBarWebElementBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- #### Returns Promise<ISize>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.getSize

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from TabBarWebElementBase.getTagName

### getText

- getText(): Promise<string>

- #### Returns Promise<string>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.getText

### getTruncation

- getTruncation(): Promise<string>

- Gets the value of `truncation` property. The truncation configuration for tab labels.

  #### Returns Promise<string>

  The value of `truncation` property.

  Inherited from TabBarWebElementBase.getTruncation

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from TabBarWebElementBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from TabBarWebElementBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from TabBarWebElementBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from TabBarWebElementBase.setProperty

### submit

- submit(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from TabBarWebElementBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from TabBarWebElementBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from TabBarWebElementBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from TabBarWebElementBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from TabBarWebElementBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  #### Throws

  if the object is not a valid encoded ID.

  Inherited from TabBarWebElementBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from TabBarWebElementBase.isId

Generated using TypeDoc